#define nMAX

/*************************************************************************/
/**Enumrations**/

typedef enum GM_BOOLEEN bool;/*Boolean*/
enum GM_BOOLEEN
{
    true=1, false=0
};

typedef enum GM_SIDE SIDE;/*SIDE enumeration*/
enum GM_SIDE
{
    UP=10, DOWN=-10,
    LEFT=-1, RIGHT=1
};

//NORMAL - picture on the top-left corner
//FIT - window resized to fit the background picture
//CENTER - picture centered in the window
//DUPLICATE - picture duplicated on X, Y or both
//(only duplication on X or Y can be fusioned with FIT - Exp: "DUPLICATE_X + FIT")
typedef enum GM_BACKGROUND_DISPLAY DISPLAY;/*Background display parameter*/
enum GM_BACKGROUND_DISPLAY
{
    NORMAL=0, FIT=100, CENTER=3,
    DUPLICATE_X=4, DUPLICATE_Y=5
};

/*************************************************************************/
/**Structures**/

typedef struct GM_PICTURE PICTURE;/*Picture Object*/
struct GM_PICTURE
{
    int x;
    int y;
    int w;
    int h;
    SDL_Surface* pic;
    bool display;
    bool locked;//si objet accessible
};

typedef struct GM_BUTTON BUTTON;/*Button object*/
struct GM_BUTTON
{
    int x;
    int y;
    int w;
    int h;
    SDL_Surface * pic;
    SDL_Surface * pic_over;
    SDL_Surface * pic_clic;
    bool over;//if mouse over button
    bool clic;//if button pressed down
    bool on;//if button activated
    bool display;//if button displayed on window
    char text[30];
    char info[100];//displayed information about the button
    bool locked;//si objet accessible
};

typedef struct GM_TEXT TEXT;/*Text object*/
struct GM_TEXT
{
    int x;
    int y;
    char str[200];
    SDL_Surface* pic;
    int size;//taille texte
    int R;//couleur RGB
    int G;
    int B;
    bool display;//if text displayed on window
    bool locked;//si objet accessible
};

typedef struct GM_MOUSE MOUSE;/*Mouse cursor*/
struct GM_MOUSE
{
    int x;//mouse clic position
    int y;//mouse clic position
    SDL_Surface* pic;//mouse picture
    bool on;//Activated
    //bool locked;//si objet accessible
};

typedef struct GM_FORM FORM;/*text Input*/
struct GM_FORM
{
    int x;
    int y;
    int w;
    int h;
    bool on;
    SDL_Surface* pic;
    SDL_Surface* pic_off;
    SDL_Surface* cursor;
    bool display;//if Form displayed on window
    TEXT* text;
    char folder[100];//pictures folder
    //MOUSE* mouse;
    bool locked;//si objet accessible
};

typedef struct GM_CHECKBOX CHECKBOX;/*Check Box*/
struct GM_CHECKBOX
{
    int x;
    int y;
    int w;
    int h;
    bool checked;//if checked or not
    bool over;//mouse over checkbox
    bool clic;//mouse clic
    SDL_Surface* pic_off;//unchecked
    SDL_Surface* pic_off_over;
    SDL_Surface* pic_off_clic;
    SDL_Surface* pic_on;//checked
    SDL_Surface* pic_on_over;
    SDL_Surface* pic_on_clic;
    bool display;//if Checkbox displayed on window
    char text[100];//checkbox text
    bool locked;//si objet accessible
};

typedef struct GM_PROGRESSBAR PROGRESSBAR;/*Progress Bar*/
struct GM_PROGRESSBAR
{
    int x;
    int y;
    int w;
    int h;
    float percent;//percentage
    bool end;//true if 100%
    SDL_Surface* pic;
    SDL_Surface* pic_full;
    bool display;//if displayed
    bool txtdisplay;//if percentage displayed
    TEXT* txt;//percentage text
    SIDE from;//from where loading begins
    //SIDE to;//where loading ends
    bool locked;//si objet accessible
};

typedef struct GM_TRACKBAR TRACKBAR;/*Track Bar*/
struct GM_TRACKBAR
{
    int x;
    int y;
    int w;
    int h;
    int size;//width of track area
    float min, max;//minimum and maximum value
    float percent;//percentage
    SDL_Surface* pic;//tracker
    SDL_Surface* pic_over;//tracker_over
    bool over;//mouse over trackbar
    bool clic;//mouse clic
    bool display;//if displayed
    SIDE from;//from where count begins
    //SIDE to;//where count ends
    bool locked;//si objet accessible
};

typedef struct GM_PAGE PAGE;/*Page*/
struct GM_PAGE
{
    int id;//page id
    int begP, endP;//pictures
    int begT, endT;//texts
    int begB, endB;//buttons
    int begF, endF;//forms
    int begCB, endCB;//checkboxs
    int begPB, endPB;//progress bars
    int begTB, endTB;//progress bars
};

